'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPortal = require('react-portal');

var _reactPortal2 = _interopRequireDefault(_reactPortal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OverflowExpander = function (_React$Component) {
  _inherits(OverflowExpander, _React$Component);

  function OverflowExpander(props) {
    _classCallCheck(this, OverflowExpander);

    var _this = _possibleConstructorReturn(this, (OverflowExpander.__proto__ || Object.getPrototypeOf(OverflowExpander)).call(this, props));

    _this.doesOverflow = function () {
      var size = _this.refs.measure.clientWidth;
      return size >= _this.props.availableWidth;
    };

    _this.handleMouseEnter = function (e) {
      var clientRect = e.target.getBoundingClientRect();
      var docWidth = document.body.getBoundingClientRect().width;
      var leftSide = clientRect.left + _this.props.availableWidth > docWidth / 2;
      var arrowWidth = 11;

      _this.setState({
        showPopover: true,
        popoverAnchorLeft: leftSide ? 'auto' : clientRect.left + _this.props.availableWidth,
        popoverAnchorRight: leftSide ? docWidth - clientRect.left + arrowWidth : 'auto',
        popoverAnchorTop: (clientRect.top + clientRect.bottom) / 2,
        popoverSide: leftSide ? 'left' : 'right'
      });
    };

    _this.handleMouseLeave = function () {
      _this.setState({
        showPopover: false
      });
    };

    _this.state = {
      doesOverflow: false,
      showPopover: false
    };
    return _this;
  }

  _createClass(OverflowExpander, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setState({ //eslint-disable-line react/no-did-mount-set-state
        doesOverflow: this.doesOverflow()
      });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var doesOverflow = this.doesOverflow();

      if (prevState.doesOverflow !== doesOverflow) {
        this.setState({ //eslint-disable-line react/no-did-update-set-state
          doesOverflow: doesOverflow
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'span',
        { onMouseEnter: this.handleMouseEnter, onMouseLeave: this.handleMouseLeave, style: {
            display: 'inline-block',
            width: this.props.availableWidth,
            overflow: 'hidden',
            textOverflow: 'ellipsis',
            whiteSpace: 'nowrap'
          } },
        _react2.default.createElement(
          'span',
          { ref: 'measure', style: {
              position: 'absolute',
              visibility: 'hidden'
            } },
          this.props.children
        ),
        _react2.default.createElement(
          'span',
          null,
          this.props.children
        ),
        _react2.default.createElement(
          _reactPortal2.default,
          { isOpened: !!(this.state.doesOverflow && this.state.showPopover) },
          _react2.default.createElement(
            'div',
            { className: 'popover fade ' + this.state.popoverSide + ' in', style: {
                display: 'block',
                position: 'absolute',
                top: this.state.popoverAnchorTop,
                left: this.state.popoverAnchorLeft,
                right: this.state.popoverAnchorRight,
                transform: 'translateY(-50%)',
                backgroundColor: '#fff'
              } },
            _react2.default.createElement('div', { className: 'arrow', style: { top: '50%' } }),
            _react2.default.createElement(
              'div',
              { className: 'popover-content', style: { wordWrap: 'break-word', overflow: 'hidden', marginRight: '14px' } },
              this.props.children
            )
          )
        )
      );
    }
  }]);

  return OverflowExpander;
}(_react2.default.Component);

OverflowExpander.propTypes = {
  availableWidth: _react2.default.PropTypes.number.isRequired,
  children: _react2.default.PropTypes.any
};
exports.default = OverflowExpander;