'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FONT_DETAILS = exports.MAX_CONTENT_WIDTH = exports.MAX_TITLE_WIDTH = exports.RETURNED_DATA_TYPES = exports.CELL_EXPANDER_SAMELINE = exports.CELL_EXPANDER_WIDTH = exports.FLEX_GROW = exports.ROW_NUMBER_COLUMN_WIDTH = exports.MIN_COLUMN_WIDTH = exports.HEADER_HEIGHT = exports.ROW_HEIGHT = exports.LINE_HEIGHT = exports.IMAGE_CELL_PADDING = exports.CELL_PADDING = exports.ColumnTypes = undefined;

var _keymirror = require('keymirror');

var _keymirror2 = _interopRequireDefault(_keymirror);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultCellPadding = {
  cellPaddingTop: 4,
  cellPaddingBottom: 0,
  cellPaddingLeft: 8,
  cellPaddingRight: 0
};

var imageCellPadding = {
  cellPaddingTop: 1,
  cellPaddingBottom: 0,
  cellPaddingLeft: 8,
  cellPaddingRight: 0
};

var cellPaddingCalculatedHeight = defaultCellPadding.cellPaddingTop + defaultCellPadding.cellPaddingBottom;

var lineHeight = 26;
var headerHeight = cellPaddingCalculatedHeight + lineHeight + 7;
var rowHeight = cellPaddingCalculatedHeight + lineHeight * 2 - 4;
var rowNumberColumnWidth = 40;

var ColumnTypes = exports.ColumnTypes = (0, _keymirror2.default)({
  IMAGE: null,
  URL: null,
  TEXT: null
});

var CELL_PADDING = exports.CELL_PADDING = defaultCellPadding;
var IMAGE_CELL_PADDING = exports.IMAGE_CELL_PADDING = imageCellPadding;
var LINE_HEIGHT = exports.LINE_HEIGHT = lineHeight;
var ROW_HEIGHT = exports.ROW_HEIGHT = rowHeight;
var HEADER_HEIGHT = exports.HEADER_HEIGHT = headerHeight;
var MIN_COLUMN_WIDTH = exports.MIN_COLUMN_WIDTH = 140;
var ROW_NUMBER_COLUMN_WIDTH = exports.ROW_NUMBER_COLUMN_WIDTH = rowNumberColumnWidth;
var FLEX_GROW = exports.FLEX_GROW = 1;
var CELL_EXPANDER_WIDTH = exports.CELL_EXPANDER_WIDTH = 35;
var CELL_EXPANDER_SAMELINE = exports.CELL_EXPANDER_SAMELINE = true;
var RETURNED_DATA_TYPES = exports.RETURNED_DATA_TYPES = ['currency', 'utc', 'text', 'alt', 'title', 'source'];
var MAX_TITLE_WIDTH = exports.MAX_TITLE_WIDTH = 140;
var MAX_CONTENT_WIDTH = exports.MAX_CONTENT_WIDTH = 700;
var FONT_DETAILS = exports.FONT_DETAILS = '15px Helvetica Neue, sans-serif';